# ラグランジュ内挿公式
# サンプルデータ
data(airmiles)
x=c(1937:1960);y=c(airmiles)
plot(airmiles,type="p")

# 多項式の次元を設定
dim=5

# 多項式の次元に必要なサンプルを抽出
Y=y[1:(dim+1)];X=x[1:(dim+1)]

# L(x)を計算する関数Lを決める
L<-function(s){
  L_f<-function(J){
    x_vec=X[-J];xj=X[J]
    return(prod((s-x_vec)/(xj-x_vec)))
  }
  vec=c()
  for(i in 1:length(X)){
    vec=c(vec,Y[i]*L_f(i))
  }
  return(sum(vec))
}

# 決められた区間内でメッシュを入れる（補完の様子を知るため）
samples=seq(min(X),max(X),0.01)

# ラグランジュ補完関数による補完値（pre）
pre=c()
for(i in 1:length(samples)){
  pre=c(pre,L(samples[i]))
}

# 補完値のプロット
plot(samples,pre,xlab="x軸",ylab="補完値",main=paste0("ラグランジュの補完公式:　",(dim),"次多項式"))

pre_dat=data.frame(x=samples,lagrange=pre)
