# シンプソンの第1公式による積分値の計算（1変数関数の積分）

# 関数の定義
func<-function(x){
  y=exp(x)
  return(y)
}

# a：積分区間の始点、a+H：積分区間の終点、n：積分区間の分割数
a=0;H=0.4;n=100000

# 重合公式の計算
Y=(H/3)*(1/(n-1))*(func(a)+func(a+H));
for(j in 1:(n-2)){
  #奇数番目は4、偶数番目は2になる係数
  coefficient=ifelse(j-floor(j/2)*2==0,4,2)
  Y=Y+((H*coefficient)/(3*(n-1)))*func(a+(j*H)/(n-1))
}

# シンプソン積分値
print(Y)

# ライブラリによる計算
integrate(func,a,a+H)
