# 指数分布の対数尤度を勾配上昇法を用いて最大化する

# 観測データを作成
x=rexp(100,rate=0.8)

# 対数尤度関数を設定
loglik<-function(lam){
  return(length(x)*log(lam)-lam*sum(x))
}

# パラメータ初期値
mu=0.1

# 反復計算回数
ite=1000

# 学習率
eta=0.0001

# 差分メッシュ
h=0.01

for(l in 1:ite){
  # パラメータを前進差分（数値微分）で更新
  mu=mu+eta*(loglik(mu+h)-loglik(mu))/h

  # 対数尤度関数の値をプロット
  print(loglik(mu))
}

# 計算されたパラメータ値
mu

# 最尤推定量
1/mean(x)
