# 2dim-newton method

# 関数定義f
f<-function(z){
  return(z[1]^2/16+z[2]^2/9-1)
}

# 関数定義g
g=function(z){
  return(z[1]^2-z[2])
}

# 初期値
A=t(t(rep(9,2)))

# 反復回数
times=10

# 差分メッシュ
h=0.01

for(j in 1:times){
  df=c();dg=c()
  for(l in 1:length(A)){
    vec=A;vec[l]=vec[l]+h
    df=c(df,(f(vec)-f(A))/h)
    dg=c(dg,(g(vec)-g(A))/h)
  }

  # 1次勾配で作成した行列
  H=t(matrix(c(df,dg),ncol=2,nrow=2))

  # 更新
  A=A-solve(H)%*%c(f(A),g(A))

  print(A)
}
