# 3dim-newton raphson

# 関数定義e
e<-function(z){
  return(z[1]+z[2]-z[3])
}

# 関数定義f
f<-function(z){
  return(z[1]^2/16+z[2]^2/9-1)
}

# 関数定義g
g<-function(z){
  return(z[1]^2-z[2])
}

# 初期値
A=t(t(rep(9,3)))

# 反復回数
times=10

# 差分メッシュ
h=0.01

for(j in 1:times){
  df=c();dg=c();de=c()

  for(l in 1:length(A)){
    vec=A;vec[l]=vec[l]+h
    df=c(df,(f(vec)-f(A))/h)
    dg=c(dg,(g(vec)-g(A))/h)
    de=c(de,(e(vec)-e(A))/h)
  }

  # 1次勾配で作成した行列
  H=t(matrix(c(df,dg,de),ncol=length(A),nrow=length(A)))

  # 更新
  A=A-solve(H)%*%c(f(A),g(A),e(A))

  print(A)
}
