# fiacco, mccormick(1968), murtagh, sargent(1969)

# 関数定義
f<-function(x){
  f1=x[1]^2+x[2]^2-1
  f2=x[1]^2-x[2]^2
  return(c(f1,f2))
}

# 初期値(1,1)
X=rep(1,2)

# ヘッシアンの近似行列の初期値
H=diag(1,length(X))

# 反復計算回数
ite=1000

# 最小点から非常にかけ離れた点になるのを防ぐためのスカラ
eta=10^(-2)

for(l in 1:ite){
  # 各代数方程式の値が入ったベクトル
  f_val=f(X)

  # 座標点に対する更新量ベクトル
  sigma=t(t(-H%*%f_val))

  # etaによって学習幅を設定し座標点を更新
  X=X+eta*sigma

  # 以前の座標点と更新された座標点の関数値の差のベクトル(y)
  y=f(X)-f_val

  # ヘッシアンの逆行列の近似行列の更新
  H=H+(eta*sigma-H%*%y)%*%t(eta*sigma-H%*%y)/as.numeric(t(y)%*%(eta*sigma-H%*%y))

  print(f(X))
}
