# levenberg(1944)

# 関数定義
f<-function(x){
  f1=x[1]^2+x[2]^2-1
  f2=x[1]^2-x[2]+1
  return(c(f1,f2))
}

# 初期値
X=rep(2,2)

# 反復計算回数
ite=500

# 学習率
eta=10^(-1)

# 差分メッシュ
h=0.01

# 正の小さいスカラ
w=0.1

for(l in 1:ite){
  # ヤコビアンを計算する箱を用意
  df=array(0,dim=c(length(X),length(X)))

  # 1次差分を用いて数値微分し、ヤコビアンを計算する
  for(j in 1:length(X)){
    vec=X;vec[j]=vec[j]+h
    df[j,]=(f(vec)-f(X))/h
  }

  # 逆行列が特異にならないよう、対角成分をwで調整
  A=df%*%t(df)+diag(w,length(X))
  y=df%*%f(X)

  # 座標点更新の際に必要なベクトルを計算
  dx=solve(A)%*%(-y)

  # 学習幅に従って座標点を更新
  X=X+eta*dx

  print(f(X))
}
