# 再急降下法で単回帰の切片と傾きを計算

# x軸方向の値
x=c(2,3,5,7,8)

# y軸方向の値
y=c(10,21,34,55,66)

# 目的関数の設定
f<-function(a,b){
  return(sum((y-a*x-b)^2))
}

# 学習幅
alpha=0.001

# 初期の切片Bと傾きA
A=1;B=1

# 反復計算回数
ite=10000

# 数値微分のための差分メッシュ
h=0.01

for(l in 1:ite){
  # 更新前の切片と傾きの値を保存
  param=c(A,B)

  # 学習幅に従って傾きを更新
  A=A-alpha*(f(param[1]+h,param[2])-f(param[1],param[2]))/h

  # 学習幅に従って切片を更新
  B=B-alpha*(f(param[1],param[2]+h)-f(param[1],param[2]))/h

  # 誤差二乗和（目的関数値）のプロット
  print(f(A,B))
}

# 最小二乗法で求まる単回帰の傾き
A_hat=cov(x,y)/var(x)

# 最小二乗法で求まる単回帰の切片
B_hat=mean(y)-mean(x)*cov(x,y)/var(x)
