library(dummies)

data(iris)

data=data.frame(iris)

# 学習率
mu=0.0001

# 特徴量行列
X=as.matrix(data[,!(colnames(data) %in% c("Species"))])

# アヤメの種類
Species=unique(data$Species)

# 目的変量の行列
Y=dummy(data$Species)

# 重み係数
W=array(1,dim=c(ncol(X),length(Species)))

# 閾値
b=array(1,dim=c(1,length(Species)))

# 反復計算回数
ite=1000000

for(j in 1:ite){
  Z=t(t(X%*%W)+c(b))

  # 予測確率（ソフトマックス）を入れる箱を用意
  pthi_vec=array(0,dim=c(nrow(Z),length(Species)))

  # 予測確率の導入
  for(i in 1:nrow(Z)){
    pthi_vec[i,]=exp(Z[i,])/sum(exp(Z[i,]))
  }

  # 重み行列の更新量を計算
  dW=t(X)%*%(Y-pthi_vec)

  # 切片の更新量の計算
  db=array(1,dim=c(1,nrow(X)))%*%(Y-pthi_vec)

  # 重みの更新
  W=W+mu*dW

  # 閾値の更新
  b=b+mu*db

  # 交差エントロピーの計算
  cross_entropy=-sum(Y*log(ifelse(pthi_vec>0,pthi_vec,1)))

  print(cross_entropy)
}
