# 母親の総数
rij=matrix(c(102,64,67,46,49,37),ncol=3)

# 以前出産事故のあった母親の総数
nij=matrix(c(20,10,26,16,27,14),ncol=3)

a=nrow(rij);b=ncol(rij)

f=function(x){
  mu=x[1];x=x[-1]
  alpha=x[1:a];x=x[-c(1:a)];
  beta=x;
  mat_ab=array(0,dim=c(a,b))
  for(i in 1:a){
    for(j in 1:b){
      mat_ab[i,j]=rij[i,j]*exp(mu+alpha[i]+beta[j])/(1+exp(mu+alpha[i]+beta[j]))
    }
  }

  mat_a=-apply(mat_ab,1,sum)+apply(nij,1,sum)
  mat_b=-apply(mat_ab,2,sum)+apply(nij,2,sum)
  mat_ab=-sum(mat_ab)+sum(nij)
  return(c(mat_ab,mat_a,mat_b))
}

# levenberg(1944)

# 初期値
X=rep(0,a+b+1)

# 反復計算回数
ite=10000

# 最小点から非常にかけ離れた点になるのを防ぐためのスカラ
eta=10^(-2)

# 差分メッシュ
h=0.01

# 正の小さいスカラ
w=0.1

for(l in 1:ite){
  # ヤコビアンを計算する箱を用意
  df=array(0,dim=c(length(X),length(X)))

  # 1次差分を用いて数値微分し、ヤコビアンを計算する
  for(j in 1:length(X)){
    vec=X;vec[j]=vec[j]+h  
    df[j,]=(f(vec)-f(X))/h  
  }

  # 逆行列が特異にならないよう、対角成分をwで調整
  A=df%*%t(df)+diag(w,length(X))
  y=df%*%f(X)

  # 座標点更新の際に必要なベクトルを計算
  dx=solve(A)%*%(-y)

  # 0で固定のパラメータの更新量を0にする
  dx[c(3,6)]=0

  # 学習幅に従って座標点を更新
  X=X+eta*dx

  print(f(X))
}

# 計算結果から主効果等のパラメータを取り出す
mu=X[1];X=X[-1];alpha=X[1:a];X=X[-c(1:a)];beta=X

pij=array(0,dim=c(a,b))

for(i in 1:a){
  for(j in 1:b){
    pij[i,j]=exp(mu+alpha[i]+beta[j])/(1+exp(mu+alpha[i]+beta[j]))
  }
}
mij_hat=rij*pij

# 尤度比検定の統計量
2*sum(nij*log(nij/mij_hat)+sum((rij-nij)*log((rij-nij)/(rij-mij_hat))))

# 自由度
df=(a-1)*(b-1)

qchisq(1-0.05,df)
