# 重み付き最小二乗法

# 母親の母数
r_data=data.frame(i=c(1,2),r1=c(102,64),r2=c(67,46),r3=c(49,37))

# 以前に出産事故のあった母親の数
n_data=data.frame(i=c(1,2),n1=c(20,10),n2=c(26,16),n3=c(27,14))
rij=as.matrix(r_data[,2:ncol(r_data)])
nij=as.matrix(n_data[,2:ncol(n_data)])
a=nrow(rij);b=ncol(rij)

# 経験ロジスティック変換
zij=log(nij/(rij-nij))

# 重み
wij=sqrt(nij*(rij-nij)/rij)

# 帰無仮説(r11=r22=0)

# 計算法1
n=matrix(c(1,1,1,0,0,0,1,0,0,1,0,0,0,1,0,0,1,0,0,0,1,0,0,1),ncol=4)

# 目的変量となるもの
yij=c(t(zij*wij))

W=c(t(wij))
W_mat=n*W

# 交互作用の列を削除
W_mat2=W_mat[,1:4]

# 正規方程式を解く
solve(t(W_mat2)%*%W_mat2)%*%t(W_mat2)%*%yij

# 計算法2
n=matrix(c(1,1,1,0,0,0,1,0,0,1,0,0,0,1,0,0,1,0,0,0,1,0,0,1),ncol=4)

# 変換後の行列
mat=n*c(t(wij))

# 正規方程式を解く
trends=solve(t(mat)%*%mat)%*%t(mat)%*%yij

# 回帰係数を取り出す
alpha=c(trends[1],0);trends=trends[-1]

mu=trends[3];trends=trends[-3]

beta=c(trends-mu,0)

# 計算されたパラメータに従い、予測値を計算する

zij_hat=array(0,dim=c(a,b))
pij=array(0,dim=c(a,b))
for(i in 1:a){
  for(j in 1:b){
    zij_hat[i,j]=mu+alpha[i]+beta[j]
    pij[i,j]=exp(zij_hat[i,j])/(1+exp(zij_hat[i,j]))
  }
}

# 交互作用がないかどうかを検定
Sr=sum(((zij_hat-zij)*wij)^2)

# Srと同等の値（もとの式）
yij%*%(diag(rep(1,6))-mat%*%solve(t(mat)%*%mat)%*%t(mat))%*%t(t(yij))

qchisq(1-0.05,df=(a-1)*(b-1))

mij_hat=rij*pij

# 適合度検定

kai2=sum((nij-mij_hat)^2/mij_hat)+sum(((rij-nij)-(rij-mij_hat))^2/(rij-mij_hat))
